/*	@pat.c - make a pattern
 */
#include <stdio.h>
#include "pat.h"

/*	form acter class sub pattern
 */
static char *getccl(register char **pp, register char *pat)
	{
	short n;
	char *p, *sp;

	p = *pp;
	if (*++p == C_NCCL)
		{
		*pat++ = P_NCCL;
		++p;
		}
	else
		*pat++ = P_CCL;
	for (sp = p; *p != C_CCLEND && *p; ++p)
		switch (*p)
			{
		case '\\':
			*pat++ = P_CCHAR;
			*pat++ = doesc(&p, "");
			break;
		case C_RANGE:
			if (p != sp && p[1] != C_CCLEND)
				{
				n = (*++p == '\\') ? doesc(&p, "") : *p;
				pat[-2] = P_RANGE;
				*pat++ = n;
				break;
				}
		default:
			*pat++ = P_CCHAR;
			*pat++ = *p;
			}
	*pat++ = P_CCLEND;
	*pp = (!p) ? --p: p;
	return (pat);
	}

char *pattern(register char *pat, char delim, char *p)
	{
	register short c;
	register char *t;
	short nlp, parstack[10], *pstack;
	char *last;

	nlp = 0;
	pstack = parstack;
	if (*p == C_SBOL)
		{
		++p;
		*pat++ = P_SBOL;
		}
	*pat++ = P_LPAR;
	*pat++ = 0;
	for (last = NULL; *p && *p != delim; ++p)
		{
		if (*p != C_CLOSE)
			last = pat;
		switch (*p)
			{
		case C_ANY:
			*pat++ = P_ANY;
			break;
		case C_ANYCLOSE:
			*pat++ = P_CLOSE;
			*pat++ = P_ANY;
			break;
		case C_SEOL:
			if (p[1] == delim || !p[1])
				*pat++ = P_SEOL;
			else
				{
				*pat++ = P_CCHAR;
				*pat++ = C_SEOL;
				}
			break;
		case C_CLOSE:
			if (!last || *last == P_LPAR || *last == P_RPAR || *last == P_CLOSE)
				{
				*pat++ = P_CCHAR;
				*pat++ = *p;
				}
			else
				{
				for (t = ++pat; t != last; --t)
					t[0] = t[-1];
				*last = P_CLOSE;
				}
			break;
		case C_CCL:
			pat = getccl(&p, pat);
			break;
		case '\\':
			if (0 <= (c = doesc(&p, "()")))
				{
				*pat++ = P_CCHAR;
				*pat++ = c;
				}
			else if (c == -1)
				{
				if (0 <= ++nlp && nlp < 10)
					{
					*pstack++ = nlp;
					*pat++ = P_LPAR;
					*pat++ = nlp;
					}
				}
			else if (c == -2)
				{
				if (10 <= nlp)
					--nlp;
				else if (0 <= nlp)
					{
					--pstack;
					*pat++ = P_RPAR;
					*pat++ = *pstack;
					}
				}
			break;
		default:
			*pat++ = P_CCHAR;
			*pat++ = *p;
			}
		}
	*pat++ = P_RPAR;
	*pat++ = 0;
	*pat++ = P_PEND;
	*pat = 0;
	return ((*p == delim && parstack == pstack) ? p : NULL);
	}
